package io.reisub.dreambot.cminer.tasks;

import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodProvider;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.interactive.Players;
import org.dreambot.api.methods.map.Tile;
import org.dreambot.api.methods.walking.impl.Walking;
import org.dreambot.api.script.TaskNode;

public class GoToSpot extends TaskNode {
    private final Tile[] SPOTS = new Tile[]{
            new Tile(2602, 3235, 0),
            new Tile(2605, 3234, 0)
    };

    @Override
    public boolean accept() {
        Tile playerTile = Players.localPlayer().getTile();
        double closestDist = Double.MAX_VALUE;

        for (Tile t : SPOTS) {
            if (t.equals(playerTile)) return false;

            closestDist = Math.min(t.distance(), closestDist);
        }

        return !Inventory.isFull() && closestDist < 15;
    }

    @Override
    public int execute() {
        Tile target = SPOTS[Calculations.random(SPOTS.length)];

        while (target.distance() > 8) {
            if (Walking.shouldWalk(Calculations.random(3, 5))) {
                Walking.walk(target);
            }

            MethodProvider.sleep(300, 500);
        }

        MethodProvider.sleepUntil(() -> !Players.localPlayer().isMoving(), Calculations.random(4000, 5000));

        Walking.walkExact(target);
        MethodProvider.sleepUntil(() -> Players.localPlayer().getTile().equals(target), Calculations.random(4000, 5000));


        return Calculations.random(250, 400);
    }
}
